### 使用

```JavaScript
//实例渲染器
this.render = new Render();
//构建一个模板,所有的node需要基于渲染器生成的模板来操作,start会返回一个模板的数组,该模板来源于LOAD内的compiler
this.templates = this.render.start();
//确保dom已经渲染上,为event准备，避免元素不存在
setTimeout(() => {
    //给每个模板绑定事件
    this.templates.forEach(i => {
        new PipeEvent()
            //设置拖拽元素
            .setDragElement(`drag${i.tag}`)
            //设置来源元素
            .setCopyElement(`origin${i.tag}`)
            //默认隐藏拖拽元素
            .dragElementHide()
            //操作回调
            .pipeEventStart({
                //按下 pipe 为PipeEvent该实例本身
                downCallback: (pipe) => {
                },
                //移动 pipe 为PipeEvent该实例本身
                moveCallback: (pipe) => {
                },
                //放起 pipeOver 为PipeEvent该实例本身 e为放弃的原生事件对象
                overCallback: (pipeOver, e) => {
                    //放起后隐藏拖拽元素
                    pipeOver.dragElementHide();
                    //开始依赖模板进行创建渲染流程 createAPI 返回一个promise,resolve其节点实例本身（注：所有的操作都应基于模板节点实例本身）
                    this.render.create(i, this.view.length + 1).then(tem => {
                        //设置节点位置
                        tem.setPosition({
                            x: e.x,
                            y: e.y
                        })
                        //设置节点大小
                        tem.setSize({
                            w: 100,
                            h: 100
                        })
                        //设置节点层级
                        tem.setZIndex(999)
                    }).then(() => {
                        //打个快照，方便undo
                        this.render.shot()
                        //更换vue组件的Array 指针，更新视图
                        this.view = this.render.getNodes()
                    })
                },
            });
    })
}, 0)
```
